*Ass 0.71
*        Device driver, device Blp_
*
*        Derek Moody. 14-6-91
*
*                        Creates QDOS device BLP, a no data-action device
*                        that performs no other function than to bleep when
*                        accessed!


Io.Name  EQU    $122
Io.SerIo EQU    $EA

         RORG   0                  Relocateable code

START    MoveQ.L #0,D0             Initialise linkage table and...
         LEA     Lnk(D0),A0
         LEA     ChannIO(D0),A1    
         MOVE.L  A1,$4(A0)
         LEA     ChanOpen(D0),A1
         Move.L  A1,$8(A0)
         LEA     ChanClse(D0),A1
         MOVE.L  A1,$C(A0)
         Move    #$20,D0            ..use MT.Liod to link driver into list.
         Trap    #1
         RTS

         CNop    0,4
Lnk      Dc.L    0                 Linkage table.
         Dc.L    0
         Dc.L    0
         Dc.L    0

HeapPtr  Dc.L    0                  Common heap block pointer - temp storage.

IPC_CMD  dc.b    $A                 Initiate sound
         dc.b    $10                  - IPC command sequence for
         dc.b    $44                           8049 slave processor
         dc.b    $44
         dc.b    $AA
         dc.b    $66
*
*        now 16 parameters, equivalent to BEEP 5000,30
*                                    - actually it's nothing like that!
         dc.b    6                pitch
         dc.b    0
         dc.b    0
         dc.b    0
         dc.b    0
         dc.b    3              wrap
         dc.b    0
         dc.b    50             duration
*
*        I don't have any of these parameters properly defined!
*                                                    so guess.
         dc.b    0
         dc.b    0
         dc.b    0                       ..no good at guessing...
         dc.b    0
         dc.b    0
         dc.b    0                      ..but zeros seem to work!
         dc.b    0
         dc.b    0
*
*        ..and finish the command.
*
         dc.b    $1

         CNop    0,4
*
*                now the access layer, the working code
*
*
*
ChannIO  Jsr     Beep
         Move.W IO.SerIo,A4        Decode IO request,
         JSR     (A4)
         Dc.L    Pend             Three..
         Dc.L    Fetch                   ..different ways..
         Dc.L    Send                                      ..to do nothing!
         RTS

ChanClse Move.L  #$19,D0
         MoveA.L HeapPtr,A0
         Trap    #1                    MT.ReCHp:  release heap space
         JSR     BEEP
         Move.L  #0,D0
         RTS
         Cnop    0,4
ChanOpen SUBQ.L  #4,A7
         MOVE.L  A7,A3              Make parameter space on stack.
         Move.W  IO.Name,A2
         Jsr     (A2)               Decode channel name.. ok?
         BRA.S   NotIt                          .. No
         Bra.S   BadPs                          .. Not quite
         Bra.S   IsOk                           .. Yes
         DC.W    3                  Length of name,
         Dc.B    'BLP'                   device name
         Dc.W    0                  no parameters - meaningless!
         Dc.W    0


BadPs    Cnop    0,4
NotIt    AddQ.L  #4,A7              Tidy stack.
         RTS
         CNop    0,4
IsOk     AddQ.L  #4,A7              Tidy stack
         Move.L  #-1,D2
         Move.L  #$40,D1
         Move.L  #$18,D0              MT.AlCHp
         Trap    #1                   allocate heap space
         Move.L  A0,D0
         LEA     HeapPtr,A0
         Move.L  D0,(A0)
         JSR     BEEP       
         MoveQ.L #0,D0
         MoveA.L HeapPtr,A0       we'll need this ref. when we close the channel.
         RTS

BEEP     LEA.L   IPC_CMD,A3         Set command pointer
         Move.L  #$11,D0            MT.IPCOM - send to slave processor
         Trap    #1
         MoveQ.L #0,D0              Error code, no errors!
         RTS

Pend     MoveQ.L  #0,D0             in a..
         RTS                              ..'REAL'..
Fetch    Move.L  #0,D1                              ..driver,
         MoveQ.L #0,D0                 all..
         RTS                                ..the hard work..
Send     MoveQ.L #0,D0                                ..would be done..
         RTS                                                         ..here.

         END

